#!/bin/bash

word="$1"
sense="$2"
wn $word -synsn >English_wholesynsets.txt
sed -n '/Sense\s'$sense'/{n;p;}' <English_wholesynsets.txt >English_synsets.txt
sed -n '/Sense\s'$sense'/{n;n;p;}' <English_wholesynsets.txt >English_ihypernyms.txt
sed -n 's/.*=>\s//p' <English_ihypernyms.txt >English_hypernyms.txt
sed -n 's/^\[\(.*\)\].*\"'$word'["(].*(N.*/\1/p' <UW-Hindi_Dict-20090403.txt >inputwords.txt
#sed -n 's/^\[\(.*\)\].*(icl>'$word').*/\1/p' <UW-Hindi_Dict-20090403.txt >>inputwords.txt
sort inputwords.txt | uniq >temporary
rm inputwords.txt
mv temporary inputwords.txt
java -cp JHWNL.jar:.  Examples >outputwords.txt
sed -n 's/^Synset.*NOUN.*\[\(.*\)\]/\1/p' <outputwords.txt >hindi_synsets.txt
sed -n 's/^Synset\s\[[0-9][0-9]*\]\s\([0-9][0-9]*\).*NOUN.*\[\(.*\)\]/\1/p' <outputwords.txt >hindi_offsets.txt
#sort hindi_synsets.txt |uniq >hindi_synsets.txt1
#rm -f hindi_synsets.txt
#mv hindi_synsets.txt1 hindi_synsets.txt
sed -n 's/^HYPERNYM.*NOUN.*\[\(.*\)\]/\1/p' <outputwords.txt >hindi_hypernym.txt
#sort hindi_hypernym.txt |uniq >hindi_hypernym.txt1
#rm -f hindi_hypernym.txt
#mv hindi_hypernym.txt1 hindi_hypernym.txt

i=0
for line in `awk 'BEGIN {FS = ", "}
{  
for (i=1; i<=NF; i++){
     print $i;
  }
}' "English_hypernyms.txt"`;
do
arr[$i]=$line
i=`expr $i + 1`
done

i=`expr $i - 1`
if [ -f "hypernyms_en2hi.txt" ];
then
rm -f hypernyms_en2hi.txt
fi

for ((k=0; k<=$i; k++));
do
sed -n 's/^\[\(.*\)\].*\"'${arr[$k]}'["(].*(N.*/\1/p' <UW-Hindi_Dict-20090403.txt >>hypernyms_en2hi.txt
#sed -n 's/^\[\(.*\)\].*(icl>'${arr[$k]}').*/\1/p' <UW-Hindi_Dict-20090403.txt >>hypernyms_en2hi.txt
done
sort hypernyms_en2hi.txt | uniq >temp
rm hypernyms_en2hi.txt
mv temp hypernyms_en2hi.txt

python match.py >line_no.txt;

line_no=0
for line in `awk '
{  
print $i;
}' "line_no.txt"`;
do
line_no=$line
done 

if [ $line_no -gt 0 ];
then
awk -v line=$line_no '{
   if(NR == line)
   print $0;
}' "hindi_synsets.txt" >mapped_synset.txt

awk -v line=$line_no '{
   if(NR == line)
   print $0;
}' "hindi_synsets.txt" >>synset.txt

awk -v line=$line_no '{
   if(NR == line)
   print $0;
}' "hindi_offsets.txt" >mapped_offset.txt

awk -v line=$line_no '{
   if(NR == line)
   print $0;
}' "hindi_offsets.txt" >>offset.txt

offset=0
for line in `awk '
{  
print $i;
}' "mapped_offset.txt"`;
do
offset=$line
done 

tr ', ' '\n' <mapped_synset.txt | sed '/^$/d' >hn_wsd.txt
python hiwsd.py hn_wsd.txt ${3}/hi/${3} ${word}#n#${sense} $offset
rm ${3}/hi/${3}_hi_tagged1.txt
mv ${3}/hi/${3}_hi_tagged.txt ${3}/hi/${3}_hi_tagged1.txt
fi
